package businessLayer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import dataLayer.Cliente;
import dataLayer.Endereco;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCliente;

public class ManipulacaoCliente {
	private RepositorioCliente generico;
	
	public ManipulacaoCliente(RepositorioCliente recebido) {
		generico = recebido;
	}
	
	public void cadastrarCliente(String cpf, String nome, Date nascimento, String logradouro,
			String complemento, String bairro, String cidade, String estado, int numero,
			String telefoneFix, String telefoneCel, String observacao) throws IOException
	{
		if(!logradouro.equals(null) && !cidade.equals(null) && !estado.equals(null))
		{
			Endereco endereco = new Endereco(logradouro,				// Se o endereo estiver poreenchido corretamente cria o mesmo. 
			complemento, bairro, cidade, estado, numero);
			
			if(!cpf.equals(null) && !nome.equals(null) && !nascimento.equals(null))
			{
				if(!telefoneCel.equals(null) || !telefoneFix.equals(null))
				{
					Cliente cliente = new Cliente(cpf, nome, nascimento, endereco, telefoneFix, telefoneCel, observacao);
					// Se o cliente estiver preenchido corretamente cria o cliente.
					
					Iterator<Cliente> comparador = generico.getIterator();
					
					boolean passa = true;
					
					while(comparador.hasNext())
					{
						if(((Cliente) comparador.next()).getCpf().equals(cliente.getCpf()))
						{
							System.out.println("###match###");
							passa = false;
						}
					}
					
					if(passa)
					{
						System.out.println("Cliente "+cliente.getNome()+" inserido!");
						generico.inserirCliente(cliente);
					}
				}
				else;								// completar com exception.
			}
			else;									// completar com exception.
		}
		else;										// completar com exception.
	}
	
	public List<Cliente> visualizarCliente(String nome)
	{
		List<Cliente> resposta = new ArrayList<Cliente>();							// Cliente de retorno  iniciado;
		Iterator<Cliente> novo = generico.getIterator();				// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (Cliente) novo.next()).getNome().contains(nome))		// Se um Cliente analizado contiver o nome buscado
			{															// a resposta enviada ser esse prprio Cliente.
				resposta.add((Cliente) novo.next());
			}
		}
		return resposta;
		
		/* Obs: o casting para Cliente  necessrio porque o objeto retornado como parmetro  genrico. */
	}
	
	public void removerCliente(String cpf)
	{
		Iterator<Cliente> novo = generico.getIterator();				// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (Cliente) novo.next()).getCpf().equals(cpf))			// Se um Cliente analizado for exatamente igual ao cpf
			{															// indicado o Cliente em questo ser removido do Vector.
				Cliente removido = (Cliente) novo.next();
				
				// DUVIDO QUE ESSE CATCH EXECUTE!
				
				try {
					this.generico.removerCliente(removido);
				} catch (IOException e) {
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
