package businessLayer;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import dataLayer.Cliente;
import dataLayer.Copia;
import dataLayer.Iterator;
import dataLayer.LocacaoIdentidade;
import dataLayer.Repositorios.Interface.RepositorioLocacao;

public class ManipulacaoLocacao {
	private RepositorioLocacao generico;
	
	public ManipulacaoLocacao(RepositorioLocacao recebido) {
		generico = recebido;
	}
	
	@SuppressWarnings("deprecation")
	public void locarFilme(Cliente cliente, Copia copia, Date inicioLocacao, Date fimLocacao) throws IOException
	{
		if(inicioLocacao.equals(fimLocacao) || inicioLocacao.before(fimLocacao))
		{
			int marcador = 0;									// Marcador nico  inicializado.
			marcador = (int) (Integer.parseInt(cliente.getCpf().substring(0,3)) + copia.getCodigo() + inicioLocacao.getDate());
			LocacaoIdentidade identada = new LocacaoIdentidade(cliente, copia, inicioLocacao, fimLocacao, marcador);
			/* Cria-se uma locao com o marcador garantidamente nico e esta  adicionada na lista. */
			
			generico.fazerLocacao(identada);
		}
	}
	
	public void cancelarLocacao(int identidade)
	{
		Iterator<LocacaoIdentidade> novo = generico.getIterator();						// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())															// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (LocacaoIdentidade) novo.next()).getIdentidade() == identidade)		// Se um Cliente analizado for exatamente igual ao cpf
			{																			// indicado o Cliente em questo ser removido do Vector.
				LocacaoIdentidade removido = (LocacaoIdentidade) novo.next();
				
				// DUVIDO QUE ESSE CATCH EXECUTE!
				
				try {
					this.generico.cancelarLocacao(removido);
				} catch (IOException e) {
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					e.printStackTrace();
				}
			}
		}
	}
	
	// Mtodo de teste.
	
	public List<LocacaoIdentidade> getLista()
	{
		Iterator<LocacaoIdentidade> novo = generico.getIterator();
		
		List<LocacaoIdentidade> resposta = new ArrayList<LocacaoIdentidade>();
		while(novo.hasNext())
		{
			resposta.add((LocacaoIdentidade) novo.next());
		}
		return resposta;
	}
}
