package businessLayer.Planilhas;
import java.io.IOException;

import businessLayer.ManipulacaoCopia;

import dataLayer.Copia;
import dataLayer.Iterator;
import dataLayer.Excel.ExcelCell;
import dataLayer.Excel.ExcelRow;
import dataLayer.Excel.ExcelSheet;
import dataLayer.Excel.ExcelWorkbook;
import dataLayer.Excel.Exception.CellNumberFormatException;
import dataLayer.Excel.Exception.CellStringFormatException;
import dataLayer.Excel.Exception.IOExcelException;
import dataLayer.Excel.Exception.NotDefinedCellException;
import dataLayer.Excel.Exception.NotDefinedRowException;
import dataLayer.Excel.Exception.SheetNotFoundException;
import dataLayer.Repositorios.Interface.RepositorioCopia;

public class PlanilhaFilmesArmazenamento {
	private RepositorioCopia repor;
	
	public PlanilhaFilmesArmazenamento(RepositorioCopia recebido)
	{
		repor = recebido;
	}

	public void colocarCopiaExcelNoRepositorio() throws IOExcelException, SheetNotFoundException, NotDefinedRowException, NotDefinedCellException, CellStringFormatException, CellNumberFormatException, IOException 
	{
		ExcelWorkbook workbook = new ExcelWorkbook("Locadora.xls"); //puxa o arquivo xls
		ExcelSheet sheet = workbook.getSheet("Filmes"); // escolhe a planilha do arquivo sobre qual quer trabalhar

		for(int i = 1; i<47; i++)
		{

			ExcelRow row = sheet.getRow(i); // Escolhe a linha que vai fazer a analise
			ExcelCell cell = row.getCell(0); //pega a celula 0 que  referente ao titulo
			String titulo = cell.getStringCellValue();  // converte o conteudo da celula em uma string

			ExcelCell cell1 = row.getCell(1); // celula 1 referente ao identificador 
			double identificador = cell1.getNumericCellValue(); // passa o identificador como double para a variavel
			if(i != 1) // comea a checar as especificaes da questao, neste caso, checa se o identificador  igual para titulos iguais (o que no pode). O i  diferente de 1 pois  o primeiro titulo e no tem anterior pra ser checado
			{
				for(int j = 1; j<i; j++) // j comea 1 para comparar com os titulos anteriores
				{
					ExcelRow row2 = sheet.getRow(j); 
					ExcelCell cell2 = row2.getCell(1);
					double comparador = cell2.getNumericCellValue();
					if(identificador == comparador) // compara o identificador do titulo em questao com os anteriores pra checar se h codigo identificador igual
					{
						identificador = 0; // caso tenha, iguala a 0 para nao poder ser armazenado no array l embaixo.
					}
				}
			}

			ExcelCell cell2 = row.getCell(2); // checa a celula referente ao tipo da copia
			String categoria = cell2.getStringCellValue();
			if(i!= 1) // faz a checagem tambem, so que agora para os tipos, onde um filme nao pode ter dois tipos diferentes. Essa checagem funciona de forma semelhante a checagem passada.
			{
				ExcelRow rowAuxiliar = sheet.getRow(i-1);
				ExcelCell cellAuxiliar = rowAuxiliar.getCell(0);
				String comparar = cellAuxiliar.getStringCellValue();
				if(comparar.equals(titulo))
				{
					ExcelCell cellAuxiliar2 = rowAuxiliar.getCell(2);
					String categoria2 = cellAuxiliar2.getStringCellValue();
					if(!categoria.equals(categoria2))
					{
						categoria = null; // caso tenham tipos diferentes um mesmo titulo fica igual a null
					}
				}
			}

			ExcelCell cell3 = row.getCell(3);
			String tipo = cell3.getStringCellValue();

			if(categoria != null && identificador !=0) // if que no armazena no array os filmes que nao atendem as especificaes
			{
				Copia filme = new Copia(titulo, identificador, categoria, tipo);
				
				Iterator<Copia> comparador = repor.getIterator();
				
				boolean passa = true;
				
				while(comparador.hasNext())
				{
					if(((Copia) comparador.next()).getCodigo() == (filme.getCodigo()))
					{
						passa = false;
					}
				}
				
				if(passa)
				{
					repor.inserirCopia(filme);
				}
			}
		}
	}

	public void transferirListaCopia(ManipulacaoCopia parametro) throws IOException
	{
		Iterator<Copia> novo = repor.getIterator();
		while(novo.hasNext())
		{
			Copia posicao = (Copia) novo.next();
			parametro.cadastrarCopia(posicao.getNome(), posicao.getCodigo(), posicao.getGenero(), posicao.getTipo());
		}
	}
}
