package businessLayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.List;

import dataLayer.Iterator;
import dataLayer.Locacao;
import dataLayer.LocacaoIdentidade;

public class RelatorioDisponibilidade {
	
	private List<LocacaoIdentidade> lista;
	private int contador;
	
	public RelatorioDisponibilidade(List<LocacaoIdentidade> locacoes) throws IOException
	{
		lista = locacoes;
		
		File numeros = new File("Numeros2.txt");
		FileReader reader = new FileReader(numeros);
		BufferedReader buff = new BufferedReader(reader);
		contador = Integer.parseInt(buff.readLine());
	}
	
	@SuppressWarnings("deprecation")
	public void imprimirRelatorioDisponibilidade(String nomeCopia, Date inicio, Date fim) throws IOException
	{
		File arquivo = new File ("RelatorioDisponibilidade"+contador+".txt");
		FileWriter texto  = new FileWriter (arquivo, true);
		PrintWriter escritor = new PrintWriter (texto, true);
		
		escritor.println("========================================");
		escritor.println("RELATRIO DE DISPONIBILIDADE");
		escritor.println("----------------------------------------");
		escritor.println("Filme: "+nomeCopia);
		
		String start = inicio.getDate()+"/"+inicio.getMonth()+"/"+inicio.getYear();
		String end = fim.getDate()+"/"+fim.getMonth()+"/"+fim.getYear();
		String periodo = start + " - " + end; 
		
		escritor.println("Perodo: "+periodo);
		escritor.println("========================================");
		escritor.println();
		
		Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
		
		while(novo.hasNext())
		{
			if(((Locacao) novo.next()).getCopia().getNome().equals(nomeCopia))
			{
				Iterator<LocacaoIdentidade> aux = new Iterator<LocacaoIdentidade>(lista);
				double numerador = ((Locacao) novo.next()).getCopia().getCodigo();
				
				escritor.println("A cpia de cdigo "+numerador+", do filme est locada nos perodos:");
				escritor.println();
				
				while(aux.hasNext())
				{	
					if(((Locacao) aux.next()).getCopia().getCodigo() == numerador)
					{
						int comecoDia = ((Locacao) aux.next()).getInicioLocacao().getDate();
						int comecoMes = ((Locacao) aux.next()).getInicioLocacao().getMonth();
						int comecoAno = ((Locacao) aux.next()).getInicioLocacao().getYear();
						String comeco = comecoDia+"/"+comecoMes+"/"+comecoAno;
						
						int terminoDia = ((Locacao) aux.next()).getFimLocacao().getDate();
						int terminoMes = ((Locacao) aux.next()).getFimLocacao().getMonth();
						int terminoAno = ((Locacao) aux.next()).getFimLocacao().getYear();
						String termino = terminoDia+"/"+terminoMes+"/"+terminoAno;
						
						escritor.println("* Entre os dias "+comeco+" e "+termino+";");
					}
				}
			}
		}
		
		contador++;
		
		FileWriter escrever = new FileWriter("Numeros2.txt");
		PrintWriter escreverMais = new PrintWriter(escrever, true);
		escreverMais.println(contador);
	}
}