package businessLayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.List;

import dataLayer.Iterator;
import dataLayer.Locacao;
import dataLayer.LocacaoIdentidade;

public class RelatorioLocacao {
	private List<LocacaoIdentidade> lista;
	private double valorTotal;
	private int contador;
	
	public RelatorioLocacao(List<LocacaoIdentidade> locacoes) throws IOException
	{
		lista = locacoes;
		valorTotal = 0;
		
		File numeros = new File("Numeros.txt");
		FileReader reader = new FileReader(numeros);
		BufferedReader buff = new BufferedReader(reader);
		contador = Integer.parseInt(buff.readLine());
	}
	
	// t com erro l embaixo (em comparar data) !
	
	@SuppressWarnings("deprecation")
	public void imprimirRelatorioLocacao(String nomeCliente, String nomeCopia, Date inicio, Date fim) throws IOException
	{
		Date invalida = new Date(1500,04,22);
		if((!inicio.equals(invalida) && !fim.equals(invalida)) || (inicio.equals(invalida) && fim.equals(invalida)))
		{
			String cliente = "Qualquer";
			String copia = "Qualquer";
			String periodo = "Qualquer";
			
			File arquivo = new File ("RelatorioLocao"+contador+".txt");
			FileWriter texto  = new FileWriter (arquivo, true);
			PrintWriter escritor = new PrintWriter (texto, true);
			
			escritor.println("========================================");
			escritor.println("RELATRIO DE LOCAES");
			escritor.println("----------------------------------------");
			
			if(!nomeCliente.equals("") && nomeCopia.equals("") && inicio.equals(invalida))
			{
				cliente = nomeCliente;
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					if(((Locacao) novo.next()).getCliente().getNome().equals(nomeCliente))
					{	
						escritor.println(novo.next().toString());
						valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(nomeCliente.equals("") && !nomeCopia.equals("") && inicio.equals(invalida))
			{
				copia = nomeCopia;
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					if(((Locacao) novo.next()).getCopia().getNome().equals(nomeCopia))
					{
						escritor.println(novo.next().toString());
						valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(nomeCliente.equals("") && nomeCopia.equals("") && !inicio.equals(invalida))
			{
				String start = inicio.getDate()+"/"+inicio.getMonth()+"/"+inicio.getYear();
				String end = fim.getDate()+"/"+fim.getMonth()+"/"+fim.getYear();
				
				periodo = start + " - " + end; 
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					Date inicioComparar =  ((Locacao) novo.next()).getInicioLocacao();
					Date fimComparar = ((Locacao) novo.next()).getFimLocacao();
					
					if(inicio.before(inicioComparar) || inicio.equals(inicioComparar));
					{
						if(fim.after(fimComparar) || fim.equals(fimComparar))
						{
							escritor.println(novo.next().toString());
							valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
						}
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(!nomeCliente.equals("") && !nomeCopia.equals("") && inicio.equals(invalida))
			{
				cliente = nomeCliente;
				copia = nomeCopia;
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					if(((Locacao) novo.next()).getCliente().getNome().equals(nomeCliente))
					{
						if(((Locacao) novo.next()).getCopia().getNome().equals(nomeCopia))
						{
							escritor.println(novo.next().toString());
							valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
						}
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(!nomeCliente.equals("") && nomeCopia.equals("") && !inicio.equals(invalida))
			{
				cliente = nomeCliente;
				
				String start = inicio.getDate()+"/"+inicio.getMonth()+"/"+inicio.getYear();
				String end = fim.getDate()+"/"+fim.getMonth()+"/"+fim.getYear();
				
				periodo = start + " - " + end;
				
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					Date inicioComparar =  ((Locacao) novo.next()).getInicioLocacao();
					Date fimComparar = ((Locacao) novo.next()).getFimLocacao();
					
					if(((Locacao) novo.next()).getCliente().getNome().equals(nomeCliente))
					{
						if(inicio.before(inicioComparar) || inicio.equals(inicioComparar));
						{
							if(fim.after(fimComparar) || fim.equals(fimComparar))
							{
								escritor.println(novo.next().toString());
								valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
							}
						}
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(nomeCliente.equals("") && !nomeCopia.equals("") && !inicio.equals(invalida))
			{
				copia = nomeCopia;
				
				String start = inicio.getDate()+"/"+inicio.getMonth()+"/"+inicio.getYear();
				String end = fim.getDate()+"/"+fim.getMonth()+"/"+fim.getYear();
				
				periodo = start + " - " + end;
				
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					Date inicioComparar =  ((Locacao) novo.next()).getInicioLocacao();
					Date fimComparar = ((Locacao) novo.next()).getFimLocacao();
					
					if(((Locacao) novo.next()).getCopia().getNome().equals(nomeCopia))
					{
						if(inicio.before(inicioComparar) || inicio.equals(inicioComparar));
						{
							if(fim.after(fimComparar) || fim.equals(fimComparar))
							{
								escritor.println(novo.next().toString());
								valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
							}
						}
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(!nomeCliente.equals("") && !nomeCopia.equals("") && !inicio.equals(invalida))
			{
				cliente = nomeCliente;
				copia = nomeCopia;
				
				String start = inicio.getDate()+"/"+inicio.getMonth()+"/"+inicio.getYear();
				String end = fim.getDate()+"/"+fim.getMonth()+"/"+fim.getYear();
				
				periodo = start + " - " + end;
				
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					Date inicioComparar =  ((Locacao) novo.next()).getInicioLocacao();
					Date fimComparar = ((Locacao) novo.next()).getFimLocacao();
					
					if(((Locacao) novo.next()).getCliente().getNome().equals(nomeCliente))
					{
						if(((Locacao) novo.next()).getCopia().getNome().equals(nomeCopia))
						{
							if(inicio.before(inicioComparar) || inicio.equals(inicioComparar));
							{
								if(fim.after(fimComparar) || fim.equals(fimComparar))
								{
									escritor.println(novo.next().toString());
									valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
								}
							}
						}
					}
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
			
			else if(nomeCliente.equals("") && nomeCopia.equals("") && inicio.equals(invalida))
			{
				escritor.println("Cliente: "+cliente);
				escritor.println("Filme: "+copia);
				escritor.println("Perodo: "+periodo);
				escritor.println("========================================");
				escritor.println();
				escritor.println("Nome do cliente | Identificador da cpia | Nome do filme | Periodo | Durao | valor");
				escritor.println();
				
				Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(lista);
				
				while(novo.hasNext())
				{
					escritor.println(novo.next().toString());
					valorTotal = valorTotal + ((Locacao) novo.next()).getValor();
				}
				escritor.println("Valor total: R$ "+valorTotal);
			}
		}
		contador++;
		
		FileWriter escrever = new FileWriter("Numeros.txt");
		PrintWriter escreverMais = new PrintWriter(escrever, true);
		escreverMais.println(contador);
	}
}
