package dataLayer.Repositorios.Arquivo;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;


import dataLayer.Iterable;
import dataLayer.Cliente;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCliente;

public class RepositorioArquivoCliente implements RepositorioCliente, Iterable<Cliente>
{
	private final File arquivo = new File("ArquivoCliente.txt");
	private List <Cliente> cadastrados;

	@SuppressWarnings("unchecked")
	public RepositorioArquivoCliente() throws IOException, ClassNotFoundException
	{
		//this.arquivo = new File("ArquivoCliente.txt"); // puxa o arquivo txt para ser utilizado
		this.cadastrados = new ArrayList<Cliente>();
		if(this.arquivo.exists())
		{	
			FileInputStream input = new FileInputStream(this.arquivo); // File Input serve para voce poder, por exemplo, ler o que est no Arquivo.
			ObjectInputStream inputObj = new ObjectInputStream (input); // possibilita trabalhar com os objetos que ja estao armazenados no arquivo.
			//@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
			this.cadastrados = (List<Cliente>) inputObj.readObject();
			System.out.println("cliente-loop");
			input.close();
		}
		else
		{
			System.out.println("cliente-anti.loop");
			FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
			ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
			outputObj.writeObject(this.cadastrados); // adiciona o arrayList no arquivo
		}
	}

	public void inserirCliente (Cliente pessoa) throws IOException
	{
		FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
		ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
		this.cadastrados.add(pessoa); // adiciona a pessoa no arraylist (objeto)
		outputObj.writeObject(this.cadastrados); // adiciona o arrayList no arquivo
	}

//	public Cliente visualizarCliente(String nome) throws IOException, ClassNotFoundException
//	{
//		/*FileInputStream input = new FileInputStream(this.arquivo); // File Input serve para voce poder, por exemplo, ler o que est no Arquivo.
//		ObjectInputStream inputObj = new ObjectInputStream (input); // possibilita trabalhar com os objetos que ja estao armazenados no arquivo.
//		@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
//		ArrayList <Cliente> auxiliar = (ArrayList<Cliente>) inputObj.readObject(); //pega o arrayList que esta no arquivo e passa para um ArrayList auxiliar.*/
//
//		Cliente auxiliarCliente = null;
//
//		Iterator<Cliente> novo = new Iterator<Cliente>(this.cadastrados);
//		while(novo.hasNext())
//		{
//			Cliente posicao = (Cliente) novo.next();
//			if(posicao.getNome().equals(nome))
//			{
//				auxiliarCliente = posicao;
//			}
//		}
//
//		return auxiliarCliente;
//	}

	public void removerCliente(Cliente c) throws IOException, ClassNotFoundException
	{
		// FAZ AS MESMAS COISAS EM RELAO AO OBJECT/FILE iNPUT ACIMA.
		/*FileInputStream input = new FileInputStream(this.arquivo);
		ObjectInputStream inputObj = new ObjectInputStream (input);
		@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
		ArrayList <Cliente> auxiliar = (ArrayList<Cliente>) inputObj.readObject();*/

				this.cadastrados.remove(c);

		//auxiliar.remove(pessoa); // remove a pessoa do arrayList

		//COMO EU TO TRABALHANDO COM SOBRESCRITA DE OBJETOS NO ARQUIVO, POIS FICA MAIS FACIL A PARTIR DO MOMENTO Q EU TBM USO ARRAYLIST, TENHO QUE ADICIONAR O NOVO ARRAYLIST (JA COM O CLIENTE REMOVIDO) PARA O ARQUIVO, POR ISSO DO CODIGO ABAIXO.

		FileOutputStream output = new FileOutputStream(this.arquivo, false);
		ObjectOutputStream outputObj = new ObjectOutputStream (output);
		outputObj.writeObject(this.cadastrados);
	}
	
	public Iterator<Cliente> getIterator()
	{
		Iterator<Cliente> resposta = new Iterator<Cliente>(cadastrados);
		return resposta;
	}
}
