package dataLayer.Repositorios.Arquivo;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

import dataLayer.Iterable;
import dataLayer.Copia;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCopia;

public class RepositorioArquivoCopia implements RepositorioCopia, Iterable<Copia>
{
	private final File arquivo = new File("ArquivoFilmes.txt");
	private List <Copia> biblioteca;

	@SuppressWarnings("unchecked")
	public RepositorioArquivoCopia() throws IOException, ClassNotFoundException
	{
		//this.arquivo = new File("ArquivoFilmes.txt"); // puxa o arquivo txt para ser utilizado
		this.biblioteca = new ArrayList<Copia>();
		if(this.arquivo.exists())
		{
			FileInputStream input = new FileInputStream(this.arquivo); // File Input serve para voce poder, por exemplo, ler o que est no Arquivo.
			ObjectInputStream inputObj = new ObjectInputStream (input); // possibilita trabalhar com os objetos que ja estao armazenados no arquivo.
			//@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
			this.biblioteca = (List<Copia>) inputObj.readObject();
			System.out.println("copia-loop");
			input.close();
		}
		else
		{
			System.out.println("copia-anti.loop");
			FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
			ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
			outputObj.writeObject(this.biblioteca); // adiciona o arrayList no arquivo
		}
	}

	public void inserirCopia (Copia filme) throws IOException
	{
		FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
		ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
		this.biblioteca.add(filme); // adiciona a pessoa no arraylist (objeto)
		outputObj.writeObject(this.biblioteca); // adiciona o arrayList no arquivo
	}

//	public Copia visualizarCopia(String nome) throws IOException, ClassNotFoundException
//	{
//		/*FileInputStream input = new FileInputStream(this.arquivo); // File Input serve para voce poder, por exemplo, ler o que est no Arquivo.
//		ObjectInputStream inputObj = new ObjectInputStream (input); // possibilita trabalhar com os objetos que ja estao armazenados no arquivo.
//		@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
//		ArrayList <Cliente> auxiliar = (ArrayList<Cliente>) inputObj.readObject(); //pega o arrayList que esta no arquivo e passa para um ArrayList auxiliar.*/
//
//		Copia auxiliarCopia = null;
//
//		Iterator<Copia> novo = new Iterator<Copia>(this.biblioteca);
//		while(novo.hasNext())
//		{
//			Copia posicao = (Copia) novo.next();
//			if(posicao.getNome().equals(nome))
//			{
//				auxiliarCopia = posicao;
//			}
//		}
//
//		return auxiliarCopia;
//	}

	public void removerCopia(Copia filme) throws IOException, ClassNotFoundException
	{
		// FAZ AS MESMAS COISAS EM RELAO AO OBJECT/FILE iNPUT ACIMA.
		/*FileInputStream input = new FileInputStream(this.arquivo);
		ObjectInputStream inputObj = new ObjectInputStream (input);
		@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
		ArrayList <Cliente> auxiliar = (ArrayList<Cliente>) inputObj.readObject();*/

		this.biblioteca.remove(filme);

		//auxiliar.remove(pessoa); // remove a pessoa do arrayList

		//COMO EU TO TRABALHANDO COM SOBRESCRITA DE OBJETOS NO ARQUIVO, POIS FICA MAIS FACIL A PARTIR DO MOMENTO Q EU TBM USO ARRAYLIST, TENHO QUE ADICIONAR O NOVO ARRAYLIST (JA COM O CLIENTE REMOVIDO) PARA O ARQUIVO, POR ISSO DO CODIGO ABAIXO.

		FileOutputStream output = new FileOutputStream(this.arquivo, false);
		ObjectOutputStream outputObj = new ObjectOutputStream (output);
		outputObj.writeObject(this.biblioteca);
	}
	
	public Iterator<Copia> getIterator()
	{
		Iterator<Copia> resposta = new Iterator<Copia>(biblioteca);
		return resposta;
	}
}
