package dataLayer.Repositorios.Arquivo;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

import dataLayer.Iterator;
import dataLayer.Iterable;
import dataLayer.LocacaoIdentidade;
import dataLayer.Repositorios.Interface.RepositorioLocacao;

public class RepositorioArquivoLocacao implements RepositorioLocacao, Iterable<LocacaoIdentidade> 
{
	private final File arquivo = new File("ArquivoLocaes.txt");
	private List <LocacaoIdentidade> registro;

	@SuppressWarnings("unchecked")
	public RepositorioArquivoLocacao() throws IOException, ClassNotFoundException
	{
		//this.arquivo = new File("ArquivoLocaes.txt"); // puxa o arquivo txt para ser utilizado
		this.registro = new ArrayList<LocacaoIdentidade>();
		if(this.arquivo.exists())
		{
			FileInputStream input = new FileInputStream(this.arquivo); // File Input serve para voce poder, por exemplo, ler o que est no Arquivo.
			ObjectInputStream inputObj = new ObjectInputStream (input); // possibilita trabalhar com os objetos que ja estao armazenados no arquivo.
			//@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
			this.registro = (List<LocacaoIdentidade>) inputObj.readObject();
			System.out.println("locacao-loop");
			input.close();
		}
		else
		{
			System.out.println("locacao-anti.loop");
			FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
			ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
			outputObj.writeObject(this.registro); // adiciona o arrayList no arquivo
		}
	}

	public void fazerLocacao (LocacaoIdentidade locacao) throws IOException
	{
		FileOutputStream output = new FileOutputStream(this.arquivo, false); // cria um File Output para poder trabalhar com o arquivo File (escrever nele por ex.). O boolean = false faz com que a cada chamada de metodo o arquivo seja sobrescrito.
		ObjectOutputStream outputObj = new ObjectOutputStream (output); // possibilita trabalhar com objetos para usar no arquivo.
		this.registro.add(locacao); // adiciona a pessoa no arraylist (objeto)
		outputObj.writeObject(this.registro); // adiciona o arrayList no arquivo
	}

	public void cancelarLocacao(LocacaoIdentidade locacao) throws IOException, ClassNotFoundException
	{
		// FAZ AS MESMAS COISAS EM RELAO AO OBJECT/FILE iNPUT ACIMA.
		/*FileInputStream input = new FileInputStream(this.arquivo);
		ObjectInputStream inputObj = new ObjectInputStream (input);
		@SuppressWarnings("unchecked")								// Impede o warning de ficar marcado.
		ArrayList <Cliente> auxiliar = (ArrayList<Cliente>) inputObj.readObject();*/

		
		this.registro.remove(locacao);

		//auxiliar.remove(pessoa); // remove a pessoa do arrayList

		//COMO EU TO TRABALHANDO COM SOBRESCRITA DE OBJETOS NO ARQUIVO, POIS FICA MAIS FACIL A PARTIR DO MOMENTO Q EU TBM USO ARRAYLIST, TENHO QUE ADICIONAR O NOVO ARRAYLIST (JA COM O CLIENTE REMOVIDO) PARA O ARQUIVO, POR ISSO DO CODIGO ABAIXO.

		FileOutputStream output = new FileOutputStream(this.arquivo, false);
		ObjectOutputStream outputObj = new ObjectOutputStream (output);
		outputObj.writeObject(this.registro);
	}

	public Iterator<LocacaoIdentidade> getIterator() {
		Iterator<LocacaoIdentidade> resposta = new Iterator<LocacaoIdentidade>(registro);
		return resposta;
	}

	
}


