package dataLayer.Repositorios.Array;

import dataLayer.Cliente;
import dataLayer.Iterable;
import dataLayer.Iterator;
import dataLayer.Repositorios.Interface.RepositorioCliente;

public class RepositorioArrayCliente implements RepositorioCliente, Iterable<Cliente>{
	private Cliente[] cadastrados;										// Array de clientes.
	private int indiceC;												/* ndice demarcador da posio do array (necessrio 
																		para adio de novos clientes e evitar estouro). */
	
	public RepositorioArrayCliente()
	{
		this.cadastrados = new Cliente[10];								// Array iniciado com 10 posies (podendo ser aumentado).
		this.indiceC = 0;												// ndice comea marcando a posio inicial.
	}
	
	private void duplicarArray()										// Mtodo de aumento do array.
	{
		Cliente[] aux = new Cliente[this.cadastrados.length*2];			// Cria um array com o dobro do tamanho atual.
		Iterator<Cliente> novo = new Iterator<Cliente>(cadastrados);	// Cria um iterator para varrer o array de clientes.
		
		while(novo.hasNext())											// A cada posio coloca o valor do iterator no array. 
		{
			aux[novo.getIndex()] = (Cliente) novo.next();
		}
		
		this.cadastrados = aux;											// Por fim transforma o array atual num de maior capacidade.
	}
	
	public void inserirCliente(Cliente c)
	{
		if(indiceC < cadastrados.length)								// Caso o nmero de clientes adicionado no ultrapasse o limite
		{																// o programa adicionar o cliente dado normalmente.
			this.cadastrados[indiceC] = c;
			this.indiceC++;
		}
		else															// Caso contrrio ele aumentar ao array e adicionar o cliente.
		{
			this.duplicarArray();
			this.cadastrados[indiceC] = c;
			this.indiceC++;
		}
	}
	
	public void removerCliente(Cliente c)
	{
		Iterator<Cliente> novo = new Iterator<Cliente>(cadastrados);	// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (Cliente) novo.next()).getCpf().equals(c.getCpf()))	// Se um Cliente analizado for exatamente igual ao cpf
			{															// indicado o Cliente em questo ser removido do Array.
				this.indiceC--;
				Cliente aux = cadastrados[indiceC];
				cadastrados[indiceC] = null;
				cadastrados[novo.getIndex()] = aux;
			}
		}
	}
	
//	public Cliente visualizarCliente(String nome)
//	{
//		Cliente resposta = null;										// Cliente de retorno  iniciado;
//		Iterator<Cliente> novo = new Iterator<Cliente>(cadastrados);	// Iterator  criado copiando-se os valores do repositrio.
//		while(novo.hasNext())											// Enquanto houver valores no Iterator estes sero analizados.
//		{
//			if(( (Cliente) novo.next()).getNome().contains(nome))		// Se um Cliente analizado contiver o nome buscado
//			{															// a resposta enviada ser esse prprio Cliente.
//				resposta = (Cliente) novo.next();
//			}
//		}
//		return resposta;
//	}
	
	public Iterator<Cliente> getIterator()
	{
		Iterator<Cliente> resposta = new Iterator<Cliente>(cadastrados);
		return resposta;
	}
}
