package dataLayer.Repositorios.Array;

import dataLayer.Iterator;
import dataLayer.Iterable;
import dataLayer.LocacaoIdentidade;
import dataLayer.Repositorios.Interface.RepositorioLocacao;

	/*Assim como a classe RepositorioVectorLocacao, a classe RepositorioArrayLocacao visa criar um marcador para as locaes, 
	logo os mtodos implementados so praticamente idnticos. Diferindo-se apenas pela categoria (Array - Vector). Outros dos
	mtodos como duplicarArray som parentes das classes RepositorioArrayCopia e RepositorioArrayCliente. Sendo assim seus
	comentrios so extremamente redundantes. */

public class RepositorioArrayLocacao implements RepositorioLocacao, Iterable<LocacaoIdentidade>{
	private LocacaoIdentidade[] registro;
	private int indiceR;
	
	public RepositorioArrayLocacao()
	{
		this.registro = new LocacaoIdentidade[10];
		this.indiceR = 0;
	}
	
	private void duplicarArray()
	{
		LocacaoIdentidade[] aux = new LocacaoIdentidade[this.registro.length*2];
		
		for(int i = 0; i<this.registro.length; i++)
		{
			aux[i] = this.registro[i];
		}
		
		this.registro = aux;
	}
	
	public void fazerLocacao(LocacaoIdentidade locacao)
	{
		if(indiceR < registro.length)
		{
			this.registro[indiceR] = locacao;
			this.indiceR++;
		}
		else 
		{
			this.duplicarArray();
			this.registro[indiceR] = locacao;
			this.indiceR++;
		}
	}
	
	public void cancelarLocacao(LocacaoIdentidade locacao)
	{
		Iterator<LocacaoIdentidade> novo = new Iterator<LocacaoIdentidade>(registro);		// Iterator  criado copiando-se os valores do repositrio.
		while(novo.hasNext())																// Enquanto houver valores no Iterator estes sero analizados.
		{
			if(( (LocacaoIdentidade) novo.next()).getIdentidade() == locacao.getIdentidade())	// Se um Cliente analizado for exatamente igual ao cpf
			{																					// indicado o Cliente em questo ser removido do Array.
				this.indiceR--;
				LocacaoIdentidade aux = registro[indiceR];
				registro[indiceR] = null;
				registro[novo.getIndex()] = aux;
			}
		}
	}
	
	public Iterator<LocacaoIdentidade> getIterator() {
		Iterator<LocacaoIdentidade> resposta = new Iterator<LocacaoIdentidade>(registro);
		return resposta;
	}
}
