package frontLayer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import java.util.Date;
import java.util.List;

import dataLayer.Cliente;
import dataLayer.Copia;
import dataLayer.LocacaoIdentidade;
import dataLayer.Excel.Exception.CellNumberFormatException;
import dataLayer.Excel.Exception.CellStringFormatException;
import dataLayer.Excel.Exception.IOExcelException;
import dataLayer.Excel.Exception.NotDefinedCellException;
import dataLayer.Excel.Exception.NotDefinedRowException;
import dataLayer.Excel.Exception.SheetNotFoundException;
import dataLayer.Repositorios.Arquivo.RepositorioArquivoCliente;
import dataLayer.Repositorios.Arquivo.RepositorioArquivoCopia;
import dataLayer.Repositorios.Arquivo.RepositorioArquivoLocacao;
import dataLayer.Repositorios.Array.RepositorioArrayCliente;
import dataLayer.Repositorios.Array.RepositorioArrayCopia;
import dataLayer.Repositorios.Array.RepositorioArrayLocacao;
import dataLayer.Repositorios.Vector.RepositorioVectorCliente;
import dataLayer.Repositorios.Vector.RepositorioVectorCopia;
import dataLayer.Repositorios.Vector.RepositorioVectorLocacao;

import businessLayer.ManipulacaoCliente;
import businessLayer.ManipulacaoCopia;
import businessLayer.ManipulacaoLocacao;
import businessLayer.RelatorioDisponibilidade;
import businessLayer.RelatorioLocacao;
import businessLayer.Planilhas.PlanilhaClienteArmazenamento;
import businessLayer.Planilhas.PlanilhaFilmesArmazenamento;
import businessLayer.Planilhas.PlanilhaLocacaoArmazenado;

public class PrimeiraClasse 
{
	private ManipulacaoCliente cliente;
	private ManipulacaoCopia copia;
	private ManipulacaoLocacao locacao;
	private RelatorioLocacao impressora;
	private RelatorioDisponibilidade leitor;
	private PlanilhaClienteArmazenamento planilhaClientes;
	private PlanilhaFilmesArmazenamento planilhaCopias;
	private PlanilhaLocacaoArmazenado planilhaLocacoes;
	 
	 public PrimeiraClasse() throws IOException, ClassNotFoundException, IOExcelException, SheetNotFoundException, NotDefinedRowException, NotDefinedCellException, CellStringFormatException, CellNumberFormatException
	 {
	 	File arquivo = new File("ArquivoInicial.txt");
	 	FileReader leitor = new FileReader (arquivo);
	 	BufferedReader leitor2 = new BufferedReader (leitor);
	 	String auxiliar = leitor2.readLine();
	 	
	 	if(auxiliar.equalsIgnoreCase("Array"))
	 	{	
	 		this.cliente = new ManipulacaoCliente (new RepositorioArrayCliente());
	 		this.copia =  new ManipulacaoCopia (new RepositorioArrayCopia());
	 		this.locacao =  new ManipulacaoLocacao (new RepositorioArrayLocacao());
	 		this.planilhaClientes = new PlanilhaClienteArmazenamento(new RepositorioArrayCliente());
	 		this.planilhaCopias = new PlanilhaFilmesArmazenamento(new RepositorioArrayCopia());
	 		this.planilhaLocacoes = new PlanilhaLocacaoArmazenado(new RepositorioArrayLocacao());
	 	}
	 	
	 	else if(auxiliar.equalsIgnoreCase("Arquivo"))
	 	{
//	 		File arquivoCliente = new File("ArquivoClientes.txt");
//	 		File arquivoFilmes = new File("ArquivoFilmes.txt");
//	 		File arquivoLocacoes = new File("ArquivoLocaes.txt");
	 			this.cliente = new ManipulacaoCliente (new RepositorioArquivoCliente());
		 		this.copia =  new ManipulacaoCopia (new RepositorioArquivoCopia());
		 		this.locacao =  new ManipulacaoLocacao (new RepositorioArquivoLocacao());
		 		System.out.println("loop-mark");
		 		this.planilhaClientes = new PlanilhaClienteArmazenamento(new RepositorioArquivoCliente());
		 		this.planilhaCopias = new PlanilhaFilmesArmazenamento(new RepositorioArquivoCopia());
		 		this.planilhaLocacoes = new PlanilhaLocacaoArmazenado(new RepositorioArquivoLocacao());
		 		System.out.println("loop-end");
	 	}
	 	
	 	else if(auxiliar.equalsIgnoreCase("Vector"))
	 	{
	 		this.cliente = new ManipulacaoCliente (new RepositorioVectorCliente());
	 		this.copia =  new ManipulacaoCopia (new RepositorioVectorCopia());
	 		this.locacao =  new ManipulacaoLocacao (new RepositorioVectorLocacao());
	 		this.planilhaClientes = new PlanilhaClienteArmazenamento(new RepositorioVectorCliente());
	 		this.planilhaCopias = new PlanilhaFilmesArmazenamento(new RepositorioVectorCopia());
	 		this.planilhaLocacoes = new PlanilhaLocacaoArmazenado(new RepositorioVectorLocacao());
	 	}
	 	
	 	System.out.println("colocar locacao start");
	 	this.planilhaLocacoes.colocarLocacaoExcelNoRepositorio();
	 	System.out.println("colocar locacao end");

	 	System.out.println("transferir locacao start");
	 	this.planilhaLocacoes.trasnferirListaLocacoes(this.locacao);
	 	System.out.println("transferir locacao end");
	 	
	 	System.out.println("colocar cliente start");
	 	this.planilhaClientes.colocarClienteExcelNoRepositorio();
	 	System.out.println("colocar cliente end");
	 	
	 	System.out.println("transferir cliente start");
	 	this.planilhaClientes.transferirListaClientes(this.cliente);
	 	System.out.println("transferir cliente end");
	 	
	 	System.out.println("colocar copia start");
	 	this.planilhaCopias.colocarCopiaExcelNoRepositorio();
	 	System.out.println("colocar copia end");

	 	System.out.println("transferir copia start");
	 	this.planilhaCopias.transferirListaCopia(this.copia);
	 	System.out.println("transferir copia end");

	 	
	 	this.impressora = new RelatorioLocacao(this.locacao.getLista());
	 	this.leitor = new RelatorioDisponibilidade(this.locacao.getLista());
	 }
	 
	 public void inserirCliente(String cpf, String nome, Date nascimento, String logradouro,
			String complemento, String bairro, String cidade, String estado, int numero,
			String telefoneFix, String telefoneCel, String observacao) throws IOException
	 {
		 cliente.cadastrarCliente(cpf, nome, nascimento, logradouro, complemento, bairro, cidade, estado, numero, telefoneFix, telefoneCel, observacao);
	 }
	 public void removerCliente(String cpf)
	 {
		 cliente.removerCliente(cpf);
	 }
	 public List<Cliente> visualisarCliente(String nome)
	 {
		 return cliente.visualizarCliente(nome);
	 }
	 
	 public void inserirCopia(String nome, double codigo, String genero, String tipo) throws IOException
	 {
		 copia.cadastrarCopia(nome, codigo, genero, tipo);
	 }
	 public void removerCopia(double codigo)
	 {
		 copia.removerCopia(codigo);
	 }
	 public List<Copia> visualisarCopia(String nome)
	 {
		 return copia.visualizarCopia(nome);
	 }
	 
	 public void inserirLocacao(Cliente cliente, Copia copia, Date inicioLocacao, Date fimLocacao) throws IOException
	 {
		 locacao.locarFilme(cliente, copia, inicioLocacao, fimLocacao);
	 }
	 public void cancelarLocacao(int identidade)
	 {
		 locacao.cancelarLocacao(identidade);
	 }
	 
	 public void imprimirRelatorioLocacao(String nomeCliente, String nomeCopia, Date inicio, Date fim) throws IOException
	 {
		 impressora.imprimirRelatorioLocacao(nomeCliente, nomeCopia, inicio, fim);
	 }
	 public void imprimirRelatorioDisponibilidade(String nomeCopia, Date inicio, Date fim) throws IOException
	 {
		 leitor.imprimirRelatorioDisponibilidade(nomeCopia, inicio, fim);
	 }
	 
	 // Metodo de testes
	 
	 public List<LocacaoIdentidade> getLocacoes()
	 {
		 return locacao.getLista();
	 }
}
